
Synnefo - Bug # 523

Status: Closed Priority: High

Author: Constantinos Venetsanopoulos Category: Cyclades UI

Created: 05/12/2011 Assignee: Christos Psaltis

Updated: 06/01/2011 Due date:

Subject: To overlay των details μετά από error δεν εμφανίζεται

Description

1. Κλείνω το server

2. Δίνω reboot

3. Μου βγάζει (σωστά) στο confirmation box: error on reboot

4. Πατώντας το "details" δεν κάνει τπτ και το confirmation box μένει αναμμένο για πάντα

Related issues:

related to Synnefo - Bug # 421: Does not work with relative URLs Closed 04/14/2011

related to Synnefo - Bug # 701: Όταν εμφανίζεται κουτί λάθους, το UI πρέπει ν... Closed 06/23/2011

Associated revisions

Revision 4e382d24 - 05/16/2011 04:50 pm - Markos Gogoulos 

add 502 error message

Refs #523

Revision 6a3cdea5 - 05/22/2011 07:11 pm - Dimitris Moraitis

return 502 error if responseText is not valid JSON - Refs #523

History

#1 - 05/14/2011 03:31 pm - Christos Psaltis

- Status changed from Assigned to Feedback

Αυτό δεν έχω καταφέρει να το αναπαράγω σε firefox, chrome και opera, μπορείς να μου δώσεις κάποιες πληεοφορίες παραπάνω;

#2 - 05/16/2011 01:47 pm - Constantinos Venetsanopoulos

1. Φτιάχνω ένα μηχάνημα

2. Το βλέπω στο GUI

3. Κάνω kill τοv runserver

4. Πατάω reboot στο μηχάνημα

5. Βγαίνει το confirmation box: error on reboot

6. Πατάω details

7. Δεν κάνει τπτ, και δεν φεύγει και το confirmation box (αφού δεν έχει βγει το overlay)

#3 - 05/16/2011 01:47 pm - Constantinos Venetsanopoulos

- Status changed from Feedback to Assigned
#4 - 05/16/2011 02:04 pm - Christos Psaltis

- Status changed from Assigned to Feedback

Κοίτα τί γίνεται στις δοκιμές που έκανα σε list και icon view:

1. Κάνω kill τοv runserver

2. Σε κάποιο μηχάνημα πατάω reboot

3. Βγαίνει το confirmation box, Confirm/Cancel

4. Πατάω confirm

5. Βγαίνει overlay με Error, code 0 κλπ 

6. Από πίσω το confirmation box έχει σβήσει

Αυτό μου το κάνει με τον ίδιο τρόπο σε όλους τους browser που δοκίμασα. Μήπως υπάρχει κάτι ακόμα που διαφοροποιεί τη συμπεριφορά στις δικές

σου δοκιμές;

#5 - 05/16/2011 02:05 pm - Constantinos Venetsanopoulos

- Status changed from Feedback to Assigned

#6 - 05/16/2011 02:22 pm - Constantinos Venetsanopoulos

Λοιπόν, δεν μπορείτε να το δείτε γιατί στη δική μας εγκατάσταση (nginx) το GUI παίρνει 502 και δεν το χειρίζεται σωστά. Παρακαλώ να γυρνάει το

GUI error για οποιονδήποτε κωδικό παίρνει, ακόμη και αν δεν είναι ένας από αυτούς που περιμένει.

#7 - 05/16/2011 05:06 pm - Markos Gogoulos

- Status changed from Assigned to Feedback

Και γω δοκιμάζω σε list+standard view:

0. Στην synnefo.js.reboot.success.ajax_error βαζω status 502 (μιας και στο τελευταιο σχολιο λες οτι το gui παιρνει 502)

1. Βλέπω το μηχάνημα μου στο ui

2. Κάνω kill τοv runserver

3. πατάω reboot στο μηχανημα μου

4. Βγαίνει το confirmation box, παταω confirm

5. Βγαίνει overlay με Error, code 0 κλπ

6. Από πίσω το confirmation box έχει σβήσει

Επίσης δοκίμασα να θέσω responseText undefined (για να δουλέψει και το άλλο if που βάζει η function ajax_error στο home.html) και πάλι η ίδια

συμπεριφορά.

Οπότε δεν ξέρω πώς αλλιώς μπορούμε να αναπαράγουμε τη συμπεριφορά που περιγράφεις.

Σημείωση: στο commit a9f5f1e πρόσθεσα το 502 στο dict με τα errors..

#8 - 05/16/2011 05:50 pm - Vangelis Koukis

Markos Gogoulos wrote:

Και γω δοκιμάζω σε list+standard view:
0. Στην synnefo.js.reboot.success.ajax_error βαζω status 502 (μιας και στο τελευταιο σχολιο λες οτι το gui παιρνει 502)

Αυτό δεν είναι το πρόβλημα, είναι άλλο θέμα.

1. Βλέπω το μηχάνημα μου στο ui

2. Κάνω kill τοv runserver

3. πατάω reboot στο μηχανημα μου

4. Βγαίνει το confirmation box, παταω confirm

Εδώ είναι το ζήτημα. Όταν πατήσεις confirm, τι ακριβώς βλέπεις;

5. Βγαίνει overlay με Error, code 0 κλπ

Σε αυτό το σημείο το confirmation box που έλεγε "Confirm" και "Cancel" έχει αντικατασταθεί από ένα κουτί, στο ίδιο σημείο που λέει "Error" on Reboot

και από κάτω Details. Δοκίμασες να πατήσεις το details; Δεν βγάζει τίποτε.

Εσύ βλέπεις overlay, δηλαδή χωριστό παράθυρο, αυτό που βγαίνει με την περιγραφή του λάθους, να σου λέει "code 0"; πότε, πώς;

αφού το κουμπί Details δεν κάνει τίποτε όταν πατιέται.

6. Από πίσω το confirmation box έχει σβήσει

να είμαστε λίγο πιο συγκεκριμένοι για το για πoιο από όλα τα boxes μιλάμε;

Επίσης δοκίμασα να θέσω responseText undefined (για να δουλέψει και το άλλο if που βάζει η function ajax_error στο home.html) και πάλι η

ίδια συμπεριφορά.

Αυτό δεν το κατάλαβα. Ας είμαστε λίγο πιο συγκεκριμένοι, δεν ξέρουμε απ'έξω όλες τις μεταβλητές και τα if του κώδικα.

Οπότε δεν ξέρω πώς αλλιώς μπορούμε να αναπαράγουμε τη συμπεριφορά που περιγράφεις.

Σημείωση: στο commit a9f5f1e πρόσθεσα το 502 στο dict με τα errors..

Αυτό δεν είναι το θέμα. Το θέμα είναι το GUI να βγάζει κουτί για οποιοδήποτε λάθος HTTP και αν πάρει.

Ναι, να έχει μια λίστα με προκαθορισμένα λάθη, και προκαθορισμένο κείμενο, όπως κάνει τώρα, αλλά πρέπει να μπορεί να εμφανίσει μήνυμα λάθους

για κάθε HTTP error code, όχι να fail silently όπως έκανε τώρα.

Όπως και νά'χει, το λάθος μάλλον είναι το εξής:

Όταν πατάω το κουμπί Details, η Javascript πετάει το εξής σφάλμα στο error console:

Error: JSON.parse

  Source File: http://62.217.120.67:8001/static/synnefo.js  

  Line: 36

και η γραμμή είναι:

responseObj = JSON.parse(responseText);

Στη συγκεκριμένη περίπτωση ο server είναι τόσο broken και δεν επιστρέφει σωστό cloudFault στο body του 502.
Οπότε, πιάστε το συγκεκριμένο exception στη γραμμή αυτή, ώστε να μην σκάει, και πείτε απλώς ότι είναι ένα μήνυμα λάθους 502, "Bad Gateway",

χωρίς details. Αυτό πρέπει να γίνεται για οποιοδήποτε HTTP λάθος: Βγάζει τον κωδικό του, προσπαθεί να ερμηνεύσει το body ως cloudFault object

σε json, δεν τα καταφέρνει, δεν βγάζει κάτι παραπάνω σε details.

#9 - 05/16/2011 05:51 pm - Vangelis Koukis

- Status changed from Feedback to Assigned

#10 - 05/22/2011 07:32 pm - Dimitris Moraitis

- Status changed from Assigned to Feedback

- Assignee changed from Christos Psaltis to Dimitris Moraitis

Eγινε στο commit:6a3cdea583c4a569c59b20c573b785a2bd059ec9

Αν το responseText δεν είναι valid JSON επιστρέφουμε σφάλμα 502.

#11 - 05/23/2011 01:50 am - Vangelis Koukis

- Status changed from Feedback to Assigned

Όχι, αυτό δεν είναι σωστό.

Όπως συζητήθηκε και στο #427, οι κωδικοί λαθών HTTP είναι από το API implementation προς το GUI, όχι από το GUI προς το χρήστη.

Το GUI έχει δικαίωμα να πει ότι έλαβε κωδικό λάθους 5xx ή 4xx μόνο αν πράγματι έλαβε τέτοιο λάθος από το χρήστη.

Σε κάθε περίπτωση, δεν είναι σφάλμα ότι το responseText δεν είναι valid JSON, και σίγουρα δεν είναι 502, 502 έτυχε να είναι ο κωδικός σφάλματος

μόνο στη συγκεκριμένη περίπτωση. Ο κωδικός του σφάλματος πρέπει να βγαίνει ακριβώς όπως έχει σταλεί από το server. Στη συγκεκριμένη

περίπτωση, θα έβγαζε κωδικό 502 όχι γιατί δεν μπορεί να ερμηνεύσει το JSON, αλλά γιατί πράγματι, έλαβε HTTP 502.

Αυτό πρέπει να γίνεται για κάθε κωδικό 5xx, 4xx χωρίς να χρειάζεται ειδική αναφορά μέσα στον κώδικα. Σήμερα ήταν ο 502 που δεν είχε

προβλεφθεί, αύριο θα είναι στάνταρ κάποιος άλλος. Όποιος κωδικός HTTP λαμβάνεται, πρέπει να εμφανίζεται στο χρήστη.

Τώρα, αν το responseText δεν είναι έγκυρο JSON, πολύ καλά, δεν θα γεμίζουν τα πεδία που εξαρτώνται από αυτό [το details και η περιγραφή του

λάθους νομίζω;] Δηλαδή, στη συγκεκριμένη περίπτωση θα έβγαζε 502 γιατί πράγματι 502 πήρε, και το details θα ήταν απλώς "No details", γιατί δεν

υπάρχει JSON να ερμηνευτεί.

Για τον ίδιο λόγο, αν ο server π.χ. επιστρέψει 401, χωρίς έγκυρο JSON body, πρέπει να εμφανιστεί κωδικός 401, με details: "No details".

Γενικά, επειδή είναι πολύ μεγάλο πρόβλημα αν το UI δεν λέει την αλήθεια για τους κωδικούς λαθών που λαμβάνει, και θα δυσκολεύει πάρα πολύ τον

εντοπισμό λαθών τώρα και στο μέλλον, φροντίστε να αναφέρεται σωστά στο χρήστη οποιοσδήποτε κωδικός επιστροφής 4xx, 5xx.

#12 - 05/25/2011 06:58 pm - Dimitris Moraitis

- Status changed from Assigned to Feedback

Vangelis Koukis wrote:

Όχι, αυτό δεν είναι σωστό.

Όπως συζητήθηκε και στο #427, οι κωδικοί λαθών HTTP είναι από το API implementation προς το GUI, όχι από το GUI προς το χρήστη.

Αυτό που λες δε βγάζει νόημα στη συγκεκριμένη περίπτωση. Το παραπάνω πρόβλημα παρατηρείται μόνο αν στηθεί ένα άλλο backend στη θέση του

API που δε στέλνει valid JSON στα error responses. Το ίδιο το API μας ξέρει να μιλάει JSON, οπότε θα ήταν λογικό όταν μας έρχεται malformed
σφάλμα, το UI να θεωρεί ότι μιλάει με έναν bad gateway και να μην εμπιστεύεται τα σφάλματα που παίρνει.

Σε κάθε περίπτωση τώρα πρέπει να δουλεύει όπως το θέλεις.

#13 - 05/25/2011 07:08 pm - Vangelis Koukis

Dimitris Moraitis wrote:

Vangelis Koukis wrote:

Όχι, αυτό δεν είναι σωστό.

Όπως συζητήθηκε και στο #427, οι κωδικοί λαθών HTTP είναι από το API implementation προς το GUI, όχι από το GUI προς το χρήστη.

Αυτό που λες δε βγάζει νόημα στη συγκεκριμένη περίπτωση. Το παραπάνω πρόβλημα παρατηρείται μόνο αν στηθεί ένα άλλο backend στη

θέση του API που δε στέλνει valid JSON στα error responses. Το ίδιο το API μας ξέρει να μιλάει JSON, οπότε θα ήταν λογικό όταν μας

έρχεται malformed σφάλμα, το UI να θεωρεί ότι μιλάει με έναν bad gateway και να μην εμπιστεύεται τα σφάλματα που παίρνει.

Σε κάθε περίπτωση τώρα πρέπει να δουλεύει όπως το θέλεις.

Το API είναι HTTP API.

Πράγματι, αν όλα πάνε καλά, θα μιλήσουμε με ένα API που θα στείλει JSON στο body της απάντησης HTTP.

Σε μια πραγματική εγκατάσταση όμως, θα υπάρχουν κι άλλα πράγματα ενδιάμεσα. Τα οποία μπορούν απλώς να επιστρέφουν έγκυρα μηνύματα

HTTP.

Από εκεί και πέρα: το UI πρέπει να είναι ειλικρινές και να κάνει ό,τι μπορεί για να αναφέρει με ακρίβεια τα λάθη.

Το λάθος HTTP είναι πραγματικότητα, άσχετα από το αν έχει JSON body ή όχι. Οπότε το UI πρέπει να πει κατ'αρχάς ότι πήρε HTTP <τάδε> και αν

μπορέσει, ας βγάλει και τα details.

Τέλος, το UI δεν μπορεί να λέει 502 αν δεν έχει δει HTTP 502. Το 502 δεν είναι κωδικός προς το χρήστη που σημαίνει "νομίζω ότι ο απέναντι είναι

bad gateway" ή ο,τιδήποτε άλλο, το UI αναφέρει τον κωδικό HTTP που το API του είπε.

Όπως και νά'χει, θα δοκιμάσω με διαφορετικές τιμές επιστροφής 4xx και 5xx από το API και αν είναι όλα ΟΚ το κλείνω.

#14 - 05/27/2011 08:21 pm - Vangelis Koukis

- Status changed from Feedback to Assigned

Vangelis Koukis wrote:

Αυτό πρέπει να γίνεται για κάθε κωδικό 5xx, 4xx χωρίς να χρειάζεται ειδική αναφορά μέσα στον κώδικα. Σήμερα ήταν ο 502 που δεν είχε

προβλεφθεί, αύριο θα είναι στάνταρ κάποιος άλλος. Όποιος κωδικός HTTP λαμβάνεται, πρέπει να εμφανίζεται στο χρήστη.

Το συγκεκριμένο έχει ειπωθεί πάνω από 5 φορές, σε 2 ή 3 διαφορετικά tickets. Και ακόμη δεν έχει υλοποιηθεί.

Δοκίμασα με συγκεκριμένο κωδικό επιστροφής για τον οποίο δεν υπάρχει σαφής πρόβλεψη στο UI (402, 413 κλπ).

Και πήρα

"Could not contact the server.

Ενέργεια: Update VMs
Κωδικός: 0

Λεπτομέριες"

Γιατί βγάζει "Κωδικός: 0", ενώ έχει σαφή κωδικό, το HTTP 402;

Δεν θα αναφερθώ εφεξής στο ζήτημα. Όλοι οι κωδικοί λάθους πρέπει να αναφέρονται όπως ακριβώς λαμβάνονται.

Vangelis Koukis wrote:

Για τον ίδιο λόγο, αν ο server π.χ. επιστρέψει 401, χωρίς έγκυρο JSON body, πρέπει να εμφανιστεί κωδικός 401, με details: "No details".

Και εδώ, βλέπω στο ui/static/synnefo.js:

} else {

        try {

            responseObj = JSON.parse(responseText);

        } catch(err) {

            errors[0] = {'code': 502}

            return errors;

        }

δηλαδή, επειδή δεν μπορεί να parse την απάντηση ως json, αναφέρει '502'. Πήρε HTTP 502; όχι.

Όταν μετά από δύο μήνες χαθούν κάποια στιγμή 2 μέρες σε debugging γιατί το UI παίρνει 502, τελικά θα ξέρουμε γιατί.

Γιατί το UI δεν αναφέρει με ακρίβεια τον κωδικό HTTP που παίρνει από τον HTTP server.

Αυτά έχουν ειπωθεί πολλές φορές.

Dimitris Moraitis wrote:

Σε κάθε περίπτωση τώρα πρέπει να δουλεύει όπως το θέλεις.

Όχι, δεν δουλεύει έτσι, και νομίζω δεν είναι σωστό να χάνουμε χρόνο έτσι.

Το ticket μένει ανοιχτό.

ΥΓ. παρακαλώ διορθώστε το "λεπτομέριες" σε "λεπτομέρειες".

#15 - 05/27/2011 09:16 pm - Dimitris Moraitis

- Status changed from Assigned to Feedback

Vangelis Koukis wrote:

Και εδώ, βλέπω στο ui/static/synnefo.js:

...

Αυτό είχε αλλάξει στο commit:07d1c0dc95ceb891f8b9b417645b2f67e9dd165b αλλά μάλλον δεν είχα κάνει git push. Τώρα πρέπει να είναι οκ.

ΥΓ. παρακαλώ διορθώστε το "λεπτομέριες" σε "λεπτομέρειες".

Έγινε κ αυτό.
#16 - 06/01/2011 11:25 am - Vangelis Koukis

- Status changed from Feedback to Assigned

Vangelis Koukis wrote:

Γιατί βγάζει "Κωδικός: 0", ενώ έχει σαφή κωδικό, το HTTP 402;

Δεν θα αναφερθώ εφεξής στο ζήτημα. Όλοι οι κωδικοί λάθους πρέπει να αναφέρονται όπως ακριβώς λαμβάνονται.

Αυτό δεν κλείνει, για τον παραπάνω λόγο.

#17 - 06/01/2011 04:38 pm - Christos Psaltis

- Status changed from Assigned to Feedback

- Assignee changed from Dimitris Moraitis to Christos Psaltis

Εδώ το πρόβλημα είναι η σειρά που γίνεται ο έλεγχος της απάντησης. Νομίζω ότι δουλεύει οκ τώρα, το δοκίμασα με μη στάνταρ κωδικούς

απάντησης χωρίς responseText, με στάνταρ κωδικούς λάθους από την api/faults και με κλείσιμο του django server. Σε όλες τις περιπτώσεις είχε

σωστή συμπεριφορά.

Υπάρχει κάποιος άλλος τρόπος που θα μπορούσα να το δοκιμάσω ώστε να βεβαιωθώ ότι όλα παίζουν οκ;

#18 - 06/01/2011 07:16 pm - Vangelis Koukis

- Status changed from Feedback to Assigned

Έλα ρε, τώρα παίζει σωστά! Γυρίζω ό,τι HTTP code θέλω και εμφανίζεται. Γυρίζω HTTP χωρίς JSON body, και βγάζει σωστά ότι δεν υπάρχουν

details. Γυρίζω HTTP error με JSON body και βγάζει σωστά λεπτομέρειες από το cloudFault. Τζετ!

Αν μπορείς κάνε ένα find-replace το "λεπτομέριες" σε "λεπτομέρειες", υπάρχει ακόμη.

Κατά τα άλλα το συγκεκριμένο είναι κομπλέ.

#19 - 06/01/2011 07:36 pm - Christos Psaltis

- Status changed from Assigned to Feedback

Έγινε και η μετάφραση στο commit:1c298d4d. Για να εμφανιστεί πρέπει να γίνει restart o server του django.

#20 - 06/01/2011 08:57 pm - Vangelis Koukis

- Status changed from Feedback to Closed

Τζετ, το κλείνω.
